//Use this class for reading and parsing .bed files with matlab. It is
//excruciatingly slow if done inside matlab.

import java.util.*;
import java.util.regex.*;
import java.io.*;


public class BedParser {

    protected String file = null;
    protected static Runtime runtime = Runtime.getRuntime();

    public BedParser() {

    }

    public BedParser(String fileName) {
	file = fileName;
    }

    public int[][] parseFile() {
	if (file!=null)
	    return parseFile(file);
	return null;
    }

    public static int[][] parseFile(String fileName) {
	int r[][] = null, nContigs = 0, i = 0;
	boolean zipped = false;
	try {
	    if (fileName.endsWith(".gz")) {
		fileName = gunzipFile(fileName);
		zipped = true;
	    }
	    BufferedReader br = new BufferedReader(new FileReader(fileName));
	    String line = br.readLine();
	    Pattern pattern = Pattern.compile("chr([\\d|X|Y])+\\s+(\\d+)\\s+(\\d+)\\s+(\\d+)");
	    while (line!=null) {
		Matcher m = pattern.matcher(line);
		if (m.find()) { nContigs++; }
		line = br.readLine();
	    }
	    br.close();
	    r = new int[nContigs][3];
	    br = new BufferedReader(new FileReader(fileName));
	    line = br.readLine();
	    while (line!=null) {
		Matcher m = pattern.matcher(line);
		if (m.find()) { 
		    r[i][0] = Integer.parseInt(m.group(2));
		    r[i][1] = Integer.parseInt(m.group(3));
		    r[i++][2] = Integer.parseInt(m.group(4));
		}
		line = br.readLine();
	    }
	    br.close();
	    if (zipped)
		gzipFile(fileName);
	}
	catch (IOException e) {

	}
	return r;
    }

    public static String gunzipFile(String fileName) {
	String fName = fileName.substring(0, fileName.length()-3);
	try {
	    runtime.exec("gunzip " + fileName);
	}
	catch (IOException e) { }
	return fName;
    }

    public static String gzipFile(String fileName) {
	try {
	    runtime.exec("gzip " + fileName);
	}
	catch (IOException e) { }
	return fileName + ".gz";
    }

}
