
import java.util.*;
import java.util.regex.*;
import java.text.DecimalFormat;
import jargs.gnu.CmdLineParser;
import java.io.*;

public class FindMers{


    public static void main(String[] args) {
	EnumerateMers em = new EnumerateMers();
	try {
	    //Handle the flags
	    //Flags used at the moment: 
	    //c, m, s
	    CmdLineParser argParser = new CmdLineParser();
	    CmdLineParser.Option merLengthFlag = argParser.addIntegerOption('m', "merLength");
	    CmdLineParser.Option chromosomeFlag = argParser.addIntegerOption('c', "chromosome");
	    CmdLineParser.Option strandFlag = argParser.addBooleanOption('s', "strand");
	    //////////////////////////////////////////////////////////////////
	    //Parse the flags
	    argParser.parse(args);
	    //The latest version of CmdLineParser seems to remove the
	    //value foreach flag when you've looked at it once. Thus
	    //we adjust our code to work with the new version.
	    Object tmp;
	    tmp = argParser.getOptionValue(merLengthFlag);
	    int merLength = tmp!=null ? ((Integer)tmp).intValue() : 35;
	    tmp = argParser.getOptionValue(chromosomeFlag);
	    int chr = tmp!=null ? ((Integer)tmp).intValue() : 18;
	    boolean strand = argParser.getOptionValue(strandFlag)!=null;
	    //////////////////////////////////////////////////////////////////
	    em.findMers(chr, merLength, strand, true);
	} catch (Exception e) {
	    System.err.println("Caught exception " + e.toString());
	    StackTraceElement s[] = e.getStackTrace();
	    for(int i=0; i<s.length; i++)
		System.err.println(s[i].toString());
	    System.err.println("There were " + em.getUniqueMers().size() + " unique and " + em.getNonUniqueMers().size() + " non-unique.");
	} // end of try-catch
    } // end of main()

}
