import java.util.*;

public class MiRNAInfo {

    protected TreeSet miRNAs = new TreeSet();
    protected int chr;

    public MiRNAInfo(int c) {
	chr = c;
    }

    public int getChromosome() { return chr; }

    public int size() { return miRNAs.size(); }

    public void add(MiRNAInfoEntry m) { miRNAs.add(m); }

    public TreeSet getMiRNAs() { return miRNAs; }

    public MiRNAInfoEntry getNearestMiRNA(int pos) {
	int nearestDist = Integer.MAX_VALUE;
	MiRNAInfoEntry nearest = null;
	Iterator it = miRNAs.iterator();
	while (it.hasNext()) {
	    MiRNAInfoEntry m = (MiRNAInfoEntry)it.next();
	    int dist = m.peakDistance(pos);
	    if (Math.abs(dist)<Math.abs(nearestDist)) {
		nearestDist = dist;
		nearest = m;
	    }
	}
	//System.out.println("Found distance " + nearestDist + " and gene " + nearestGene.toString() + " for peak " + pos);
	return nearest;
    }

    /*public void findNearbyPeaks(TreeSet peaks, int cutOff) {
	//Find the peaks which are within cutOff and not closer to any
	//other annotated gene.
	Iterator it = peaks.iterator();
	while (it.hasNext()) {
	    ChromosomeWindow peak = (ChromosomeWindow)it.next();
	    Iterator it2 = genes.iterator();
	    while (it2.hasNext()) {
		MRNAInfoEntry gene = (MRNAInfoEntry)it2.next();
		if (gene.getStrand()) {
		    if (gene.getStart() - cutOff<peak.getCenterOfMass() && gene.getEnd() + cutOff>peak.getCenterOfMass())
			gene.addNearbyPeak(peak);
		}
		else {
		    if (gene.getStart() + cutOff>peak.getCenterOfMass() && gene.getEnd() - cutOff<peak.getCenterOfMass())
			gene.addNearbyPeak(peak);
		}
	    }
	}
    }



    public MRNAInfoEntry getGene(String name) {
	Iterator it = genes.iterator();
	while (it.hasNext()) {
	    MRNAInfoEntry m = (MRNAInfoEntry)it.next();
	    String n = m.name;
	    if (n.toLowerCase().equals(name.toLowerCase()))
		return m;
	}
	return null;
    }

    public MRNAInfoEntry getGene(int id) {
	Iterator it = genes.iterator();
	while (it.hasNext()) {
	    MRNAInfoEntry m = (MRNAInfoEntry)it.next();
	    if (m.id==id)
		return m;
	}
	return null;
    }

    public int numberOfProximalOrInternal(int peakPos, int promoterLength) {
	//Use this method to find the number of genes which are
	//internal or proximal with respect to this peak.
	int nGenes = 0;
	Iterator it = genes.iterator();
	while (it.hasNext()) {
	    MRNAInfoEntry m = (MRNAInfoEntry)it.next();
	    nGenes += (m.peakInternal(peakPos) || m.isProximal(peakPos, promoterLength)) ? 1 : 0;
	}
	return nGenes;
    }

    public TreeMap alignTSS(int nUpstream, int nDownstream, ABIRead sortedReads[]) {
	//Use this method to find the distribution of reads in the
	//promoter regions of all genes.
	TreeMap histRelPos = new TreeMap();
	Iterator it = genes.iterator();
	while (it.hasNext()) {
	    MRNAInfoEntry gene = (MRNAInfoEntry)it.next();
	    histRelPos = gene.getReadsInPromoterRegion(sortedReads, nUpstream, nDownstream, histRelPos);
	}
	return histRelPos;
	}*/

}
