

import jargs.gnu.CmdLineParser;
import java.io.*;
import java.text.DecimalFormat;

public class MotifScan {

    public static DecimalFormat format = new DecimalFormat("###.########");

    public static void main(String args[]) {
	try {
	    //Handle the flags
	    //Flags used at the moment: 
	    CmdLineParser argParser = new CmdLineParser();
	    //Use this flag to for the location of the .fa-files
	    CmdLineParser.Option fileNameFlag = argParser.addStringOption('n', "fileName");
	    
	    //////////////////////////////////////////////////////////////////
	    //Parse the flags
	    argParser.parse(args);
	    //The latest version of CmdLineParser seems to remove the
	    //value foreach flag when you've looked at it once. Thus
	    //we adjust our code to work with the new version.
	    String matrixFile = "", fileName = "", dirName = "";
	    boolean orchestra = true;
	    double pVal = 0;
	    //////////////////////////////////////////////////////////////////
	    if (matrixFile.equals("mef2"))
		matrixFile = "";
		BufferedReader br = new BufferedReader(new FileReader(fileName));
		String line = br.readLine(), seq = "";
		while (line!=null) {
		    if (!line.startsWith(">")) 
			seq += line;
		    else {
			if (seq.length()>0) {
			    TFMScanner tfmScanner = new TFMScanner(seq, matrixFile, orchestra);
			    tfmScanner.findMotifs(pVal, dirName);
			    long[] motifLocs = tfmScanner.getMotifLocations(matrixFile);
			    seq = ""; //start looking at a new sequence
			}
		    }
		    line = br.readLine();
		}
	    

	}
	catch (Exception e) {
	    System.err.println("Caught exception " + e.toString());
	    StackTraceElement s[] = e.getStackTrace();
	    for(int i=0; i<s.length; i++)
		System.err.println(s[i].toString());
	} // end of try-catch
    }


}
